{********************************************************}
{*                  Unit FMANAGE v1.23                  *}
{*      Copyright (c) 1996-98 by Dmitry Beloshistov     *}
{*                   BDSLIB v1.02                       *}
{*        File operation in DOS Real mode & DPMI        *}
{********************************************************}
{*
 History of changes:
      18-12-98,BDS, DPMI compatible
      01-10-98,BDS, long file name support
      10-10-98,BDS, some bug fixed for longnames
      11-10-98,BDS, some procedures and functions was rewrited in ASM
*}

Unit Fmanage;
{$R-,A+,V-,X+,G+,F+}
Interface
Uses Dos,Lfn,Strings,WinVer,FaFuncs;

const StartPath:string='';
      LfnUse:boolean=false; {long file name use flag}

Var FileNameSet:set of char;

function ValidFileName(var FileName: PathStr): Boolean;
function IsDirName(DirName: string): boolean;
function IsFileName(FileName: string): boolean;
function FileExist(FileName: string): Boolean;
function DirExist(DirName: string): Boolean;
procedure Fdel(FileName: string; Var ErrCode: byte);
procedure FDelAll(var ErrCode:byte); {20-10-98,BDS}
procedure Frename(SourceFile,TargetFile: string; Var ErrCode: byte);
procedure Unique(Path: String; Var FileName: String);
Function Drives:string;
Procedure CopyFile(Source,Target:String;var Er:byte);
Procedure AppendFile(Source,Target:string; var Er:Byte);
Function GetFileSize(FileName:String):longint;
Function GetCurDrive:char;           {11-09-1998,BDS}
Procedure SetCurDrive(Drive:Char);   {11-09-1998,BDS}
Function NumOfCD:Word;               {11-09-1998,BDS}
Function CDPresent:boolean;          {11-09-1998,BDS}
Function CDDrives:string;            {11-09-1998,BDS}
Procedure DelTreeFiles(Path:String);
Procedure FDelAllDir(var Er:byte);
Procedure DelTreeDirs(Path:String);
Function NetPresent:boolean;                 {24-11-98,BDS}
Function IsRemoteDrive(DrvNum:byte):boolean; {24-11-98,BDS}
Function DrvType(Drv:Char):byte;             {24-11-98,BDS}
Procedure GetFileDate(FName:String; var D,M,Y:Word); {25-12-98,BDS}
Procedure GetFileTime(FName:String; var H,M,S:Word); {25-12-98,BDS}
Function NewFileExt(FName,NewExt:String):string; {05-01-98,BDS}
Function GetFileExt(s:string):string;            {10-01-98,BDS}
Function IsFNameChar(Ch:Char):boolean;           {10-01-98,BDS}
Procedure FFSplit(S:String; var D,N,E:String);
Function ExtrName(S:String):string;
Function ExtrPath(S:String):string;
Function GetLongName(ShortName:String):string;
Function MakeDir(s:String):word;
Function GetCurDir(Drive:byte; var Dir:String):word;
Function GetShortName(s:String):string;
Function SetArchAttr(FileName:String):Word;
Procedure SetFileAttr(FileName:String; Attr:word);
Function IsReservedFile(FileName:String):boolean;
Function GetBootDrive:byte;
Function GetBootDriveCh:Char;
Function TempFileNameDec:String;
Function TempFileNameHex:String;

Implementation

{$S+}
Procedure DelTreeFiles(Path:String);
{deleting ALL files in directory}
var DR:SearchRec;
    Er:Byte;
begin
  if Path[length(Path)]='\' then dec(byte(Path[0]));
  ChDir(Path);
  FindFirst('*.*',Directory,DR);
  while DosError = 0 do
  begin
   if (DR.Attr and Directory)=Directory then
    begin
     if (DR.Name<>'.') and (DR.Name<>'..') then
      begin
        ChDir(DR.Name);
        DelTreeFiles(Dr.Name);       { Recursion!!! }
        ChDir('..');
      end
    end;
    FindNext(DR);
  end;
  FDelAll(Er);
end;
{$S-}
{-------------------------------------------------}
Procedure FDelAllDir(var Er:byte);
var Sr:SearchRec;
begin
 Er:=0;
 FindFirst('*.*',Directory,Sr);
 while dosError=0 do
  begin
   FindNext(Sr);
   {$I-}
   RmDir(Sr.Name);
   {$I+}
   if IOResult<>0 then Er:=1;
   FindNext(Sr);
  end;
end;
{-------------------------------------------}
{$S+}
Procedure DelTreeDirs(Path:String);
var DR:SearchRec; ER:Byte;
begin
  if Path[length(Path)]='\' then dec(byte(Path[0]));
  ChDir(Path);
  FindFirst('*.*',Directory,DR);
  while DosError = 0 do
  begin
   if (DR.Attr and Directory)=Directory then
    begin
     if (DR.Name<>'.') and (DR.Name<>'..') then
      begin
        ChDir(DR.Name);
        DelTreeFiles(DR.Name);       { Recursion!!! }
        ChDir('..');
      end
    end;
    FindNext(DR);
  end;
  FDelAllDir(Er);
end;
{$S-}
{--------------------------------------------}
Function IsDirName(DirName: string): boolean; { BDS }
Var
  i: byte;
  ch: char;
  ok: boolean;
begin                              { IsDirName }
  ok:=true; ch:=DirName[1];
  if Pos(':',DirName)>0 then ok:=(ch in ['A'..'Z','a'..'z']);
  if ok and (Pos(':',DirName)>2) then ok:=false;
  if ok and (Pos(':',DirName)=2) then
  begin
    Delete(DirName,1,2); if Pos(':',DirName)>0 then ok:=false;
  end;
  if ok then
  for i:=1 to length(DirName) do
    begin
     ch:=DirName[i]; if not (ch in FileNameSet) then ok:=false;
    end;
  IsDirName:=ok;
end;

Function IsFileName(FileName: string): boolean;
Var
  i: byte;
  ch: char;
  ok: boolean;
  Dir: DirStr;
  Name: NameStr;
  Ext: ExtStr;
  tmp: string;
begin                                 { IsFileName }
  ok:=true;
  Fsplit(FileName,Dir,Name,Ext);
  if Name='' then begin IsFileName:=false; Exit; end;
  ok:=IsDirName(Dir);
  if ok then
  for i:=1 to length(Name) do
  begin
    ch:=Name[i]; if not (ch in FileNameSet-[':']) then ok:=false;
  end;
  if ok then
  begin
    if (length(Ext)>0) and (Ext[length(Ext)]='.') then
    begin
      tmp:=Ext; Delete(tmp,length(tmp),1); Ext:=tmp;
    end;
    if Ext[1]='.' then
      for i:=2 to length(Ext) do
      begin
        ch:=Ext[i]; if not (ch in FileNameSet-[':','.','\']) then ok:=false;
      end
    else if length(Ext)>0 then ok:=false;
  end;
  isfilename:=ok;
end;                                  { IsFileName }

function sFileExist(FileName: string): Boolean;
{ Dos FileExist (for short names) }
Var Sr:SearchRec;
    Flag:boolean;
begin                          { FileExist }
  Flag:=(Pos('*.*',FileName)<>0);
  sFileExist:=False;
  if FileName<>'' then
   begin
    if Flag then begin
                   FindFirst(FileName,AnyFile-VolumeID-Directory,Sr);
                   while (DosError=0) do
                     begin
                      if (Sr.Name<>'.') and (Sr.Name<>'..') then break;
                      FindNext(Sr);
                     end;
                   sFileExist:=(DosError=0);
                end
    else begin
          FindFirst(FileName,AnyFile-VolumeID-Directory,Sr);
          sFileExist:=(DosError=0);
         end;
   end;
end;                            { FileExist }

Function FileExist(FileName:String):boolean;
begin
 if not lfnuse then FileExist:=sFileExist(FileName)
 else FileExist:=lFileExist(FileName);
end;

function sDirExist(DirName:string):Boolean;
Var Sr:SearchRec;
begin
 {if DirName[length(DirName)]='\' then dec(byte(DirName[0]));} {08-10-98,BDS}
  DirName:=Dls(DirName);     {10-10-1998,BDS}
  if DirName='' then sDirExist:=false
  else begin
        FindFirst(DirName,Directory,Sr);
        sDirExist:=(DosError=0);
       end;
end;

Function DirExist(DirName:String):boolean;
begin
 if LfnUse then DirExist:=lDirExist(DirName) {10-10-1998,BDS}
 else DirExist:=sDirExist(DirName);
end;

procedure Fdel(FileName: string; Var ErrCode: byte);
var reg: registers;
    F:File;
begin                                                     { Fdel }
  Assign(F,FileName);
  SetFAttr(F,Archive);                                    {13-11-98,BDS}
  if DosError<>0 then begin ErrCode:=DosError; exit; end;
  FileName:=concat(FileName,#0);
  reg.ds:=Seg(FileName[1]); reg.dx:=Ofs(FileName[1]);
  reg.ah:=$41;
  MsDos(reg);
  if (reg.flags AND FCarry)=1 then ErrCode:=reg.ax
  else ErrCode:=0;
end;                                    { Fdel }

procedure Frename(SourceFile,TargetFile: string; Var ErrCode: byte);
var
  reg: registers;
begin                                   { Frename }
  SourceFile:=concat(SourceFile,#0);
  TargetFile:=concat(TargetFile,#0);
  reg.ds:=Seg(SourceFile[1]); reg.dx:=Ofs(SourceFile[1]);
  reg.es:=Seg(TargetFile[1]); reg.di:=Ofs(TargetFile[1]);
  if lfnuse then reg.ax:=$7156    {08-09-1999,BDS,longnames support}
  else reg.ah:=$56;
  MsDos(reg);
  ErrCode:=0;
  if (reg.flags AND FCarry)=1 then ErrCode:=reg.ax;
end;                                    { Frename }

Procedure Unique(Path: String; Var FileName: String);
Var
  reg: Registers;
  i: integer;
  ErrCode: Byte;
begin                                      { Unique }
  FileName:='';
  if Path='' then Exit;
  for i:=1 to 15 do Path:=concat(Path,#0);
  reg.ds:=Seg(Path[1]); reg.dx:=Ofs(Path[1]);
  reg.cx:=0;
  reg.ah:=$5A;
  MsDos(reg);
  ErrCode:=0;
  if (reg.flags AND FCarry)=1 then ErrCode:=reg.ax;
  if ErrCode=0 then
  begin
    FileName:=Path;
    i:=1;
    while (i<length(FileName)) and (FileName[i]<>#0) do Inc(i);
    if FileName[i]=#0 then Delete(FileName,i,length(FileName)-i+1);
    { delete the zero file created by DOS }
    reg.ds:=Seg(Path[1]); reg.dx:=Ofs(Path[1]);
    reg.ah:=$3E;
    reg.bx:=reg.ax;
    MsDos(reg);
  end;
end;                                      { Unique }

function DriveValid(Drive: Char): Boolean; near; assembler;
asm
        MOV     AH,19H          { Save the current drive in BL }
        INT     21H
        MOV     BL,AL
        MOV     DL,Drive        { Select the given drive }
        SUB     DL,'A'
        MOV     AH,0EH
        INT     21H
        MOV     AH,19H          { Retrieve what DOS thinks is current }
        INT     21H
        MOV     CX,0            { Assume false }
        CMP     AL,DL           { Is the current drive the given drive? }
        JNE     @@1
        MOV     CX,1            { It is, so the drive is valid }
        MOV     DL,BL           { Restore the old drive }
        MOV     AH,0EH
        INT     21H
@@1:    XCHG    AX,CX           { Put the return value into AX }
end;

function PathValid(var Path:PathStr): Boolean;
var
  ExpPath: PathStr;
  SR: SearchRec;
begin
  ExpPath := FExpand(Path);
  if Length(ExpPath) <= 3 then PathValid := DriveValid(ExpPath[1])
  else
  begin
    if ExpPath[Length(ExpPath)] = '\' then Dec(ExpPath[0]);
    FindFirst(ExpPath, Directory, SR);
    PathValid := (DosError = 0) and (SR.Attr and Directory <> 0);
  end;
end;

function ValidFileName(var FileName: PathStr): Boolean;
const
  IllegalChars = ';,=+<>|"[] \';
var
  Dir: DirStr;
  Name: NameStr;
  Ext: ExtStr;
{ Contains returns true if S1 contains any characters in S2 }

function Contains(S1, S2: String): Boolean; near; assembler;
asm
        PUSH    DS
        CLD
        LDS     SI,S1
        LES     DI,S2
        MOV     DX,DI
        XOR     AH,AH
        LODSB
        MOV     BX,AX
        OR      BX,BX
        JZ      @@2
        MOV     AL,ES:[DI]
        XCHG    AX,CX
@@1:    PUSH    CX
        MOV     DI,DX
        LODSB
        REPNE   SCASB
        POP     CX
        JE      @@3
        DEC     BX
        JNZ     @@1
@@2:    XOR     AL,AL
        JMP     @@4
@@3:    MOV     AL,1
@@4:    POP     DS
end;

begin
  ValidFileName := True;
  FSplit(FileName, Dir, Name, Ext);
  if not ((Dir = '') or PathValid(Dir)) or Contains(Name, IllegalChars) or
    Contains(Dir,IllegalChars) then ValidFileName := False;
end;



FUNCTION Drives: STRING; ASSEMBLER;
VAR
   DriveInfo:   ARRAY[1..2]  OF CHAR;
   Buffer:      ARRAY[1..40] OF CHAR;
   DriveString: ARRAY[1..25] OF CHAR;
ASM
     PUSH   SI                     { Save Important Registers }
     PUSH   DI
     PUSH   ES
     PUSH   DS
     MOV    SI, SS                 { The Stack Segment (SS) points to the }
     MOV    DS, SI                 { VAR's above.  Point DS to it... }
     PUSH   DS
     POP    ES                     { ...and ES as well. }
     LEA    SI, DriveInfo          { DS:SI - Where we test each drive letter }
     LEA    DI, Buffer             { ES:DI - FCB Buffer }
     LEA    BX, DriveString        { DS:BX - Our resultant string }
     MOV    BYTE PTR [SI], '@'     { The character before 'A' }
     XOR    CX, CX                 { Zero out CX }
@Scan:
     INC    BYTE PTR [SI]          { Next Drive Letter }
     MOV    BYTE PTR [SI+1], ':'
     MOV    AX, $2906              { DOS Function 29h - Parse Filename }
     INT    21h                    { DS:SI - String to be parsed,ES:DI - FCB }
     LEA    SI, DriveInfo          { DS:SI }
     CMP    AL, $FF                { AL = FFh if function fails (invalid }
     JE     @NotValid              {     drive letter) }
     INC    CX                     { Add one more to our string length... }
     PUSH   CX                     { ...and save it. }
     MOV    CL, BYTE PTR DS:[SI]   { Grab the valid drive letter... }
     MOV    [BX], CL               { ...and stuff it into our result }
     INC    BX                     { Next position in result string }
     POP    CX                     { Get our length counter back }
@NotValid:
     CMP    BYTE PTR [SI], 'Z'     { Did we go through all letters? }
     JNE    @Scan                  { Nope, so next letter }
     LEA    SI, DriveString        { Store DriveString to #Result }
     LES    DI, @Result
     INC    DI
     REP    MOVSB
     XCHG   AX, DI                 { This is the only way to store the }
     MOV    DI, WORD PTR @Result   {   length that I can get to work. }
     SUB    AX, DI
     DEC    AX
     STOSB
     POP    DS                     { Restore Important Registers }
     POP    ES
     POP    DI
     POP    SI
END;

type PCopyBuffer=^TCopyBuffer;
     TCopyBuffer=array[0..65534] of byte; {64Kb Buffer!}

Procedure CopyFile(Source,Target:string; var Er:Byte);
var F1,F2:File;
    Rb,Wb:Word;
    Buffer:PCopyBuffer;
begin
 if not FileExist(Source) then begin Er:=1; exit; end; {- no source file found -}
 Assign(F1,Source);
 reset(F1,1);
 Assign(F2,Target);
 {$I-}
 rewrite(F2,1);
 {$I+}
 if IOResult<>0 then begin Er:=2; exit; end; {- invalid target file -}
 Buffer:=New(PCopyBuffer);
 repeat
  BlockRead(F1,Buffer^,SizeOf(TCopyBuffer),Rb);
  BlockWrite(F2,Buffer^,Rb,Wb);
 until (Rb=0) or (Rb<>Wb);
 Dispose(Buffer);  {bugfix! 03-08-1998, BDS }
 if Rb<>Wb then Er:=3 {- no enougth room or another Dos error -}
 else Er:=0; {- success -}
 close(F1);
 close(F2);
end;

Procedure AppendFile(Source,Target:string; var Er:Byte);
var F1,F2:File;
    Rb,Wb:Word;
    Buffer:PCopyBuffer;
begin
 if not FileExist(Source) then begin Er:=1; exit; end; {- no source file found -}
 Assign(F1,Source);
 reset(F1,1);
 Assign(F2,Target);
 {$I-}
 reset(F2,1);
 {$I+}
 if IOResult<>0 then begin Er:=2; exit; end; {- invalid target file -}
 Seek(F2,FileSize(F2));
 Buffer:=New(PCopyBuffer);
 repeat
  BlockRead(F1,Buffer^,SizeOf(TCopyBuffer),Rb);
  BlockWrite(F2,Buffer^,Rb,Wb);
 until (Rb=0) or (Rb<>Wb);
 Dispose(Buffer);     {bugfix! 03-08-1998, BDS }
 if Rb<>Wb then Er:=3 {- no enougth room or another Dos error -}
 else Er:=0;          {- success -}
 close(F1);
 close(F2);
end;

Function GetFileSize(FileName:String):longint;  {8-09-1998,BDS}
var Sr:SearchRec;
begin
 if not FileExist(FileName) then GetFileSize:=-1 {File not found}
 else begin
       FileName:=GetShortName(FileName);        {10-09-1998,BDS}
       FindFirst(FileName,AnyFile,Sr);
       GetFileSize:=Sr.Size;
      end;
end;

Function GetCurDrive:char; assembler;       {11-09-1998,BDS}
asm
   MOV AH,19h
   INT 21H
   ADD AL,'A'
end;

Procedure SetCurDrive(Drive:Char);
begin                                       {11-09-1998,BDS}
 Drive:=UpCase(Drive);
 asm
   MOV AH,0Eh
   MOV DL,Drive
   SUB DL,'A'
   INT 21h
 end;
end;

Function NumOfCD:word; assembler;        {11-09-1998,BDS}
asm
   MOV AX,1500h
   MOV BX,0000h
   INT 2Fh
   MOV AX,BX
end;

Function CDPresent:boolean;                 {11-09-1998,BDS}
begin
 CDPresent:=(NumOfCD<>0);
end;

Function CDDrives:string;                   {11-09-1998,BDS}
var Buffer:array[0..45] of byte;
    S:String;
    I:byte;
    e_s:Word;
    b_x:word;
begin
e_s:=Seg(Buffer); b_x:=ofs(Buffer);
if not CDPresent then begin CDDrives:=''; exit; end;
 asm
    PUSH ES
    MOV AX,150Dh
    MOV DX,E_S
    MOV ES,DX
    MOV BX,B_X
    INT 2Fh
    POP ES
 end;
 S:='';
 For I:=0 to (NumOfCD-1) do S:=S+char(Buffer[I]+byte('A'));
 CDDrives:=S;
end;

Procedure FDelAll(var ErrCode:byte);
var SR:SearchRec;
begin
 FindFirst('*.*',AnyFile-VolumeID-Directory,Sr);
 while DosError=0 do
  begin
   FDel(Sr.Name,ErrCode);
   if ErrCode<>0 then Break;
   FindNext(Sr);
  end;
end;

Function NetPresent:boolean; assembler;
asm
   mov ax,1000h
   int 2fh
   cmp al,0
   je  @@1
   mov al,false
   jmp @@2
@@1:
   mov al,true
@@2:
end;

Function IsRemoteDrive(DrvNum:byte):boolean; assembler;
asm
   mov ax,4409h
   mov bl,DrvNum
   int 21h
   jc @@1
   and dx,0A00h
   cmp dx,0
   jne @@1
   mov al,true   {remote}
   jmp @@2
@@1:
   mov al,false  {error or local}
@@2:
end;

Function IsFloppyDrive(NDrv:Byte):Byte; assembler;
asm
   mov ax,4408h
   mov bl,NDrv
   int 21h
   jc  @error
   jmp @enddetect
@error:
   mov al,0ffh
@enddetect:
end;

Function DriveRemovable(NDrv:byte):Byte; far;
var Result:Byte;
begin
 Result:=IsFloppyDrive(NDrv);
 if Result=$FF then DriveRemovable:=2
 else DriveRemovable:=Result;
end;

Function DrvType(Drv:Char):byte;
{0 - removable, 1-fixed (hard), 2 - CD-ROM, 3 - remote (NetWork) 255 - error}
const DriveChars='ABCDEFGHIJKLMNOPQRSTUVWXY';
var NDrv:Byte;
    s:string;

     Function IsCD:boolean;
     begin
      IsCD:=CDPresent and (Pos(Drv,CDDrives)<>0)
     end;
begin
Drv:=UpCase(Drv);
NDrv:=DriveRemovable(Pos(Drv,DriveChars));
if NDrv=2 then
  begin
   if isCD then DrvType:=2 {test for CD}
   else begin
          if IsRemoteDrive(Pos(Drv,DriveChars)) and NetPresent then DrvType:=3
          else begin
                if IsRemoteDrive(Pos(Drv,DriveChars)) then DrvType:=4
                else DrvType:=$FF;
               end;
        end;
  end
 else DrvType:=NDrv;
end;

Procedure GetFileTime(FName:String; var H,M,S:Word);
var DT:DateTime;
    Sr:SearchRec;
begin
 FName:=GetShortName(FName);            {10-10-1998,BDS}
 FindFirst(FName,AnyFile-VolumeID,Sr);
 if DosError<>0 then begin h:=$FFFF; M:=$FFFF; S:=$FFFF; end
 else begin
       UnPackTime(Sr.Time,DT);
       H:=DT.Hour; M:=DT.Min; S:=DT.Sec;
      end;
end;

Procedure GetFileDate(FName:String; var D,M,Y:Word);
var DT:DateTime;
    Sr:SearchRec;
begin
 FName:=GetShortName(FName);            {10-10-1998,BDS}
 FindFirst(FName,AnyFile-VolumeID,Sr);
 if DosError<>0 then begin D:=$FFFF; M:=$FFFF; Y:=$FFFF; end
 else begin
       UnPackTime(Sr.Time,DT);
       D:=DT.Day; M:=DT.Month; Y:=DT.Year;
      end;
end;

Function NewFileExt(FName,NewExt:String):string;
var D:DirStr;
    N:NameStr;
    E:ExtStr;
begin
 if Pos('.',NewExt)=0 then NewExt:='.'+NewExt; { }
 FSplit(FName,D,N,E);
 NewFileExt:=D+N+NewExt;
end;

Function GetFileExt(s:string):string;
{--- return file extension (for examp. .EXE .TXT etc.) -----------}
var D:DirStr; N:NameStr; E:ExtStr;
begin
 FSplit(s,D,N,E); GetFileExt:=E;
end;

Function ExtrName(S:String):string;
var D,N,E:String;
begin
 FFSplit(S,D,N,E);
 ExtrName:=N+E;
end;

Function ExtrPath(S:String):string;
var d,n,e:string;
begin
 ffsplit(s,d,n,e);
 ExtrPath:=d;
end;

Procedure FFsplit(S:String; var D,N,E:String);
var I:Byte;
begin
 D:='';
 while (Pos('\',s)<>0) and (s<>'') do
  begin
   D:=D+S[1];
   delete(s,1,1);
  end;
 N:='';
 E:='';
 while (s[1]<>'.') and (S<>'') do
  begin
   N:=N+S[1];
   delete(s,1,1);
  end;
 E:=S;
end;

Function IsFNameChar(Ch:Char):boolean;
begin
 IsFNameChar:=(Ch in FileNameSet);
end;

Function GetLongName(ShortName:String):string;
var SNm,LNm:Array[0..261] of char;
begin
if lfnuse then
   begin
    StrPCopy(SNm,ShortName);
    LGetLongName(SNm,LNm);
    GetLongName:=StrPas(LNm);
   end
 else GetLongName:=ShortName;
end;

Function MakeDir(s:String):word;
var LNm:array[0..261] of char;
begin
 if lfnuse then begin StrPCopy(LNm,S); MakeDir:=LMkDir(LNm); end
 else begin {$I-} MkDir(S); {$I+} MakeDir:=IOResult; end;
end;

Function GetCurDir(Drive:byte; var Dir:String):word;
var Lnm:array[0..261] of char;
begin
 if lfnuse then begin lgetdir(Drive,lnm); Dir:=strpas(lnm); end
 else GetDir(0,Dir);
end;

Function GetShortName(s:String):string;
var lnm,snm:array[0..261] of char;
begin
 if lfnuse then
  begin strpcopy(lnm,s); lGetShortName(lnm,snm); GetShortName:=strpas(snm); end
 else GetShortName:=s;
end;

Function SetArchAttr(FileName:String):word;
var f:file;
    Attr:Word;
begin
 if not FileExist(FileName) then SetArchAttr:=0
 else begin
       FileMode:=0;
       FileName:=GetShortName(FileName); {10-10-1998,BDS}
       Assign(f,FileName);
       GetFAttr(f,Attr);
       SetFAttr(f,Archive);
       SetArchAttr:=Attr;
      end;
end;

Procedure SetFileAttr(FileName:String; Attr:Word);
var f:file;
begin
 if not FileExist(FileName) then exit;
 FileMode:=0;
 FileName:=GetShortName(FileName); {10-10-1998,BDS}
 Assign(f,FileName);
 SetFAttr(f,Attr);
end;

Function IsReservedFile(FileName:String):boolean;
begin
 FileName:=ExtrName(FileName);
 IsReservedFile:=(Pos(' '+FileName+' ',
                      ' CLOCK$ CON AUX COM1 COM4 COM3 COM4 NUL PRN ')>0);
end;

Function GetBootDrive:byte; assembler;
asm
   mov ax,3305h
   int 21h
   xor ax,ax
   mov al,dl
end;

Function GetBootDriveCh:Char; assembler;
asm
   call GetBootDrive
   add  al,'@'      { 40h - '@', 41h - 'A' }
end;

Function TempFileNameDec:String;
var St:String;
begin
 repeat
  St:=Copy(lz(random($FF))+lz(random($FF))+lz(random($FF))+lz(random($FF)),1,8)+'.tmp';
 until not FileExist(St);
 TempFileNameDec:=St;
end;

Function TempFileNameHex:String;
var St:String;
begin
repeat
 St:=Copy(IntToHex(random($FF))+IntToHex(random($FF))+
          IntToHex(random($FF))+IntToHex(random($FF)),1,8)+'.tmp';
until not FileExist(St);
 TempFileNameHex:=St;
end;

begin
  FileNameSet:=['!','#'..')',#45,#46,'0'..':','@'..'Z','\','`'..#123,
                #125,'~','_'];
  StartPath:=dls(ExtrPath(ParamStr(0)));
  LfnUse:=LongNameSupport; {20-01-2000,BDS,update}
end.
